# Copyright 2014-2018 Intel Corporation.
#
# This software and the related documents are Intel copyrighted  materials,  and
# your use of  them is  governed by the  express license  under which  they were
# provided to you (License).  Unless the License provides otherwise, you may not
# use, modify, copy, publish, distribute,  disclose or transmit this software or
# the related documents without Intel's prior written permission.
#
# This software and the related documents  are provided as  is,  with no express
# or implied  warranties,  other  than those  that are  expressly stated  in the
# License.



from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_daal', [dirname(__file__)])
        except ImportError:
            import _daal
            return _daal
        if fp is not None:
            try:
                _mod = imp.load_module('_daal', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _daal = swig_import_helper()
    del swig_import_helper
else:
    import _daal
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


__version__ = "2018.0.3.20180405"
## @package daal Main module


_daal.batch_swigconstant(_daal)
batch = _daal.batch

_daal.distributed_swigconstant(_daal)
distributed = _daal.distributed

_daal.online_swigconstant(_daal)
online = _daal.online

_daal.step1Local_swigconstant(_daal)
step1Local = _daal.step1Local

_daal.step2Master_swigconstant(_daal)
step2Master = _daal.step2Master

_daal.step3Local_swigconstant(_daal)
step3Local = _daal.step3Local

_daal.step4Local_swigconstant(_daal)
step4Local = _daal.step4Local

_daal.step2Local_swigconstant(_daal)
step2Local = _daal.step2Local

_daal.step3Master_swigconstant(_daal)
step3Master = _daal.step3Master

_daal.step5Master_swigconstant(_daal)
step5Master = _daal.step5Master

_daal.dram_swigconstant(_daal)
dram = _daal.dram

_daal.mcdram_swigconstant(_daal)
mcdram = _daal.mcdram
class Base(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Base, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Base, name)
    __repr__ = _swig_repr
    __swig_destroy__ = _daal.delete_Base
    __del__ = lambda self: None

    def __init__(self):
        this = _daal.new_Base()
        try:
            self.this.append(this)
        except:
            self.this = this
Base_swigregister = _daal.Base_swigregister
Base_swigregister(Base)
cvar = _daal.cvar
DAAL_MALLOC_DEFAULT_ALIGNMENT = cvar.DAAL_MALLOC_DEFAULT_ALIGNMENT
SERIALIZATION_HOMOGEN_NT_ID = cvar.SERIALIZATION_HOMOGEN_NT_ID
SERIALIZATION_AOS_NT_ID = cvar.SERIALIZATION_AOS_NT_ID
SERIALIZATION_SOA_NT_ID = cvar.SERIALIZATION_SOA_NT_ID
SERIALIZATION_DATACOLLECTION_ID = cvar.SERIALIZATION_DATACOLLECTION_ID
SERIALIZATION_KEYVALUEDATACOLLECTION_ID = cvar.SERIALIZATION_KEYVALUEDATACOLLECTION_ID
SERIALIZATION_DATAFEATURE_NT_ID = cvar.SERIALIZATION_DATAFEATURE_NT_ID
SERIALIZATION_DATADICTIONARY_NT_ID = cvar.SERIALIZATION_DATADICTIONARY_NT_ID
SERIALIZATION_DATADICTIONARY_DS_ID = cvar.SERIALIZATION_DATADICTIONARY_DS_ID
SERIALIZATION_MATRIX_NT_ID = cvar.SERIALIZATION_MATRIX_NT_ID
SERIALIZATION_CSR_NT_ID = cvar.SERIALIZATION_CSR_NT_ID
SERIALIZATION_PACKEDSYMMETRIC_NT_ID = cvar.SERIALIZATION_PACKEDSYMMETRIC_NT_ID
SERIALIZATION_PACKEDTRIANGULAR_NT_ID = cvar.SERIALIZATION_PACKEDTRIANGULAR_NT_ID
SERIALIZATION_MERGE_NT_ID = cvar.SERIALIZATION_MERGE_NT_ID
SERIALIZATION_ROWMERGE_NT_ID = cvar.SERIALIZATION_ROWMERGE_NT_ID
SERIALIZATION_HOMOGEN_TENSOR_ID = cvar.SERIALIZATION_HOMOGEN_TENSOR_ID
SERIALIZATION_TENSOR_OFFSET_LAYOUT_ID = cvar.SERIALIZATION_TENSOR_OFFSET_LAYOUT_ID
SERIALIZATION_MKL_TENSOR_ID = cvar.SERIALIZATION_MKL_TENSOR_ID
SERIALIZATION_OPTIONAL_RESULT_ID = cvar.SERIALIZATION_OPTIONAL_RESULT_ID
SERIALIZATION_MEMORY_BLOCK_ID = cvar.SERIALIZATION_MEMORY_BLOCK_ID
SERIALIZATION_LINEAR_REGRESSION_MODELNORMEQ_ID = cvar.SERIALIZATION_LINEAR_REGRESSION_MODELNORMEQ_ID
SERIALIZATION_LINEAR_REGRESSION_MODELQR_ID = cvar.SERIALIZATION_LINEAR_REGRESSION_MODELQR_ID
SERIALIZATION_LINEAR_REGRESSION_PARTIAL_RESULT_ID = cvar.SERIALIZATION_LINEAR_REGRESSION_PARTIAL_RESULT_ID
SERIALIZATION_LINEAR_REGRESSION_TRAINING_RESULT_ID = cvar.SERIALIZATION_LINEAR_REGRESSION_TRAINING_RESULT_ID
SERIALIZATION_LINEAR_REGRESSION_PREDICTION_RESULT_ID = cvar.SERIALIZATION_LINEAR_REGRESSION_PREDICTION_RESULT_ID
SERIALIZATION_LINEAR_REGRESSION_SINGLE_BETA_RESULT_ID = cvar.SERIALIZATION_LINEAR_REGRESSION_SINGLE_BETA_RESULT_ID
SERIALIZATION_LINEAR_REGRESSION_GROUP_OF_BETAS_RESULT_ID = cvar.SERIALIZATION_LINEAR_REGRESSION_GROUP_OF_BETAS_RESULT_ID
SERIALIZATION_PCA_RESULT_ID = cvar.SERIALIZATION_PCA_RESULT_ID
SERIALIZATION_PCA_PARTIAL_RESULT_CORRELATION_ID = cvar.SERIALIZATION_PCA_PARTIAL_RESULT_CORRELATION_ID
SERIALIZATION_PCA_PARTIAL_RESULT_SVD_ID = cvar.SERIALIZATION_PCA_PARTIAL_RESULT_SVD_ID
SERIALIZATION_PCA_TRANSFORM_RESULT_ID = cvar.SERIALIZATION_PCA_TRANSFORM_RESULT_ID
SERIALIZATION_PCA_QUALITY_METRIC_RESULT_ID = cvar.SERIALIZATION_PCA_QUALITY_METRIC_RESULT_ID
SERIALIZATION_STUMP_MODEL_ID = cvar.SERIALIZATION_STUMP_MODEL_ID
SERIALIZATION_STUMP_TRAINING_RESULT_ID = cvar.SERIALIZATION_STUMP_TRAINING_RESULT_ID
SERIALIZATION_ADABOOST_MODEL_ID = cvar.SERIALIZATION_ADABOOST_MODEL_ID
SERIALIZATION_ADABOOST_TRAINING_RESULT_ID = cvar.SERIALIZATION_ADABOOST_TRAINING_RESULT_ID
SERIALIZATION_BROWNBOOST_MODEL_ID = cvar.SERIALIZATION_BROWNBOOST_MODEL_ID
SERIALIZATION_BROWNBOOST_TRAINING_RESULT_ID = cvar.SERIALIZATION_BROWNBOOST_TRAINING_RESULT_ID
SERIALIZATION_LOGITBOOST_MODEL_ID = cvar.SERIALIZATION_LOGITBOOST_MODEL_ID
SERIALIZATION_LOGITBOOST_TRAINING_RESULT_ID = cvar.SERIALIZATION_LOGITBOOST_TRAINING_RESULT_ID
SERIALIZATION_NAIVE_BAYES_MODEL_ID = cvar.SERIALIZATION_NAIVE_BAYES_MODEL_ID
SERIALIZATION_NAIVE_BAYES_PARTIALMODEL_ID = cvar.SERIALIZATION_NAIVE_BAYES_PARTIALMODEL_ID
SERIALIZATION_NAIVE_BAYES_RESULT_ID = cvar.SERIALIZATION_NAIVE_BAYES_RESULT_ID
SERIALIZATION_NAIVE_BAYES_PARTIAL_RESULT_ID = cvar.SERIALIZATION_NAIVE_BAYES_PARTIAL_RESULT_ID
SERIALIZATION_SVM_MODEL_ID = cvar.SERIALIZATION_SVM_MODEL_ID
SERIALIZATION_SVM_TRAINING_RESULT_ID = cvar.SERIALIZATION_SVM_TRAINING_RESULT_ID
SERIALIZATION_MULTI_CLASS_CLASSIFIER_MODEL_ID = cvar.SERIALIZATION_MULTI_CLASS_CLASSIFIER_MODEL_ID
SERIALIZATION_MULTICLASS_CLASSIFIER_RESULT_ID = cvar.SERIALIZATION_MULTICLASS_CLASSIFIER_RESULT_ID
SERIALIZATION_COVARIANCE_PARTIAL_RESULT_ID = cvar.SERIALIZATION_COVARIANCE_PARTIAL_RESULT_ID
SERIALIZATION_COVARIANCE_RESULT_ID = cvar.SERIALIZATION_COVARIANCE_RESULT_ID
SERIALIZATION_KMEANS_PARTIAL_RESULT_ID = cvar.SERIALIZATION_KMEANS_PARTIAL_RESULT_ID
SERIALIZATION_KMEANS_RESULT_ID = cvar.SERIALIZATION_KMEANS_RESULT_ID
SERIALIZATION_KMEANS_INIT_PARTIAL_RESULT_ID = cvar.SERIALIZATION_KMEANS_INIT_PARTIAL_RESULT_ID
SERIALIZATION_KMEANS_INIT_STEP2LOCAL_PP_PARTIAL_RESULT_ID = cvar.SERIALIZATION_KMEANS_INIT_STEP2LOCAL_PP_PARTIAL_RESULT_ID
SERIALIZATION_KMEANS_INIT_STEP3MASTER_PP_PARTIAL_RESULT_ID = cvar.SERIALIZATION_KMEANS_INIT_STEP3MASTER_PP_PARTIAL_RESULT_ID
SERIALIZATION_KMEANS_INIT_STEP4LOCAL_PP_PARTIAL_RESULT_ID = cvar.SERIALIZATION_KMEANS_INIT_STEP4LOCAL_PP_PARTIAL_RESULT_ID
SERIALIZATION_KMEANS_INIT_STEP5MASTER_PP_PARTIAL_RESULT_ID = cvar.SERIALIZATION_KMEANS_INIT_STEP5MASTER_PP_PARTIAL_RESULT_ID
SERIALIZATION_KMEANS_INIT_RESULT_ID = cvar.SERIALIZATION_KMEANS_INIT_RESULT_ID
SERIALIZATION_CLASSIFIER_TRAINING_PARTIAL_RESULT_ID = cvar.SERIALIZATION_CLASSIFIER_TRAINING_PARTIAL_RESULT_ID
SERIALIZATION_CLASSIFIER_BINARY_CONFUSION_MATRIX_RESULT_ID = cvar.SERIALIZATION_CLASSIFIER_BINARY_CONFUSION_MATRIX_RESULT_ID
SERIALIZATION_CLASSIFIER_MULTICLASS_CONFUSION_MATRIX_RESULT_ID = cvar.SERIALIZATION_CLASSIFIER_MULTICLASS_CONFUSION_MATRIX_RESULT_ID
SERIALIZATION_CLASSIFIER_PREDICTION_RESULT_ID = cvar.SERIALIZATION_CLASSIFIER_PREDICTION_RESULT_ID
SERIALIZATION_CLASSIFIER_TRAINING_RESULT_ID = cvar.SERIALIZATION_CLASSIFIER_TRAINING_RESULT_ID
SERIALIZATION_MOMENTS_PARTIAL_RESULT_ID = cvar.SERIALIZATION_MOMENTS_PARTIAL_RESULT_ID
SERIALIZATION_MOMENTS_RESULT_ID = cvar.SERIALIZATION_MOMENTS_RESULT_ID
SERIALIZATION_IMPLICIT_ALS_MODEL_ID = cvar.SERIALIZATION_IMPLICIT_ALS_MODEL_ID
SERIALIZATION_IMPLICIT_ALS_PARTIALMODEL_ID = cvar.SERIALIZATION_IMPLICIT_ALS_PARTIALMODEL_ID
SERIALIZATION_IMPLICIT_ALS_PREDICTION_RATINGS_PARTIAL_RESULT_ID = cvar.SERIALIZATION_IMPLICIT_ALS_PREDICTION_RATINGS_PARTIAL_RESULT_ID
SERIALIZATION_IMPLICIT_ALS_PREDICTION_RATINGS_RESULT_ID = cvar.SERIALIZATION_IMPLICIT_ALS_PREDICTION_RATINGS_RESULT_ID
SERIALIZATION_IMPLICIT_ALS_TRAINING_INIT_RESULT_ID = cvar.SERIALIZATION_IMPLICIT_ALS_TRAINING_INIT_RESULT_ID
SERIALIZATION_IMPLICIT_ALS_TRAINING_INIT_PARTIAL_RESULT_BASE_ID = cvar.SERIALIZATION_IMPLICIT_ALS_TRAINING_INIT_PARTIAL_RESULT_BASE_ID
SERIALIZATION_IMPLICIT_ALS_TRAINING_INIT_PARTIAL_RESULT_ID = cvar.SERIALIZATION_IMPLICIT_ALS_TRAINING_INIT_PARTIAL_RESULT_ID
SERIALIZATION_IMPLICIT_ALS_TRAINING_INIT_DISTRIBUTED_PARTIAL_RESULT_STEP2_ID = cvar.SERIALIZATION_IMPLICIT_ALS_TRAINING_INIT_DISTRIBUTED_PARTIAL_RESULT_STEP2_ID
SERIALIZATION_IMPLICIT_ALS_TRAINING_RESULT_ID = cvar.SERIALIZATION_IMPLICIT_ALS_TRAINING_RESULT_ID
SERIALIZATION_IMPLICIT_ALS_DISTRIBUTED_PARTIAL_RESULT_STEP1_ID = cvar.SERIALIZATION_IMPLICIT_ALS_DISTRIBUTED_PARTIAL_RESULT_STEP1_ID
SERIALIZATION_IMPLICIT_ALS_DISTRIBUTED_PARTIAL_RESULT_STEP2_ID = cvar.SERIALIZATION_IMPLICIT_ALS_DISTRIBUTED_PARTIAL_RESULT_STEP2_ID
SERIALIZATION_IMPLICIT_ALS_DISTRIBUTED_PARTIAL_RESULT_STEP3_ID = cvar.SERIALIZATION_IMPLICIT_ALS_DISTRIBUTED_PARTIAL_RESULT_STEP3_ID
SERIALIZATION_IMPLICIT_ALS_DISTRIBUTED_PARTIAL_RESULT_STEP4_ID = cvar.SERIALIZATION_IMPLICIT_ALS_DISTRIBUTED_PARTIAL_RESULT_STEP4_ID
SERIALIZATION_ASSOCIATION_RULES_RESULT_ID = cvar.SERIALIZATION_ASSOCIATION_RULES_RESULT_ID
SERIALIZATION_CHOLESKY_RESULT_ID = cvar.SERIALIZATION_CHOLESKY_RESULT_ID
SERIALIZATION_CORRELATION_DISTANCE_RESULT_ID = cvar.SERIALIZATION_CORRELATION_DISTANCE_RESULT_ID
SERIALIZATION_COSINE_DISTANCE_RESULT_ID = cvar.SERIALIZATION_COSINE_DISTANCE_RESULT_ID
SERIALIZATION_EM_GMM_INIT_RESULT_ID = cvar.SERIALIZATION_EM_GMM_INIT_RESULT_ID
SERIALIZATION_EM_GMM_RESULT_ID = cvar.SERIALIZATION_EM_GMM_RESULT_ID
SERIALIZATION_KERNEL_FUNCTION_RESULT_ID = cvar.SERIALIZATION_KERNEL_FUNCTION_RESULT_ID
SERIALIZATION_OUTLIER_DETECTION_MULTIVARIATE_RESULT_ID = cvar.SERIALIZATION_OUTLIER_DETECTION_MULTIVARIATE_RESULT_ID
SERIALIZATION_OUTLIER_DETECTION_UNIVARIATE_RESULT_ID = cvar.SERIALIZATION_OUTLIER_DETECTION_UNIVARIATE_RESULT_ID
SERIALIZATION_OUTLIER_DETECTION_BACON_RESULT_ID = cvar.SERIALIZATION_OUTLIER_DETECTION_BACON_RESULT_ID
SERIALIZATION_PIVOTED_QR_RESULT_ID = cvar.SERIALIZATION_PIVOTED_QR_RESULT_ID
SERIALIZATION_QR_RESULT_ID = cvar.SERIALIZATION_QR_RESULT_ID
SERIALIZATION_QR_ONLINE_PARTIAL_RESULT_ID = cvar.SERIALIZATION_QR_ONLINE_PARTIAL_RESULT_ID
SERIALIZATION_QR_DISTRIBUTED_PARTIAL_RESULT_ID = cvar.SERIALIZATION_QR_DISTRIBUTED_PARTIAL_RESULT_ID
SERIALIZATION_QR_DISTRIBUTED_PARTIAL_RESULT_STEP3_ID = cvar.SERIALIZATION_QR_DISTRIBUTED_PARTIAL_RESULT_STEP3_ID
SERIALIZATION_QUANTILES_RESULT_ID = cvar.SERIALIZATION_QUANTILES_RESULT_ID
SERIALIZATION_WEAK_LEARNER_RESULT_ID = cvar.SERIALIZATION_WEAK_LEARNER_RESULT_ID
SERIALIZATION_SVD_RESULT_ID = cvar.SERIALIZATION_SVD_RESULT_ID
SERIALIZATION_SVD_ONLINE_PARTIAL_RESULT_ID = cvar.SERIALIZATION_SVD_ONLINE_PARTIAL_RESULT_ID
SERIALIZATION_SVD_DISTRIBUTED_PARTIAL_RESULT_ID = cvar.SERIALIZATION_SVD_DISTRIBUTED_PARTIAL_RESULT_ID
SERIALIZATION_SVD_DISTRIBUTED_PARTIAL_RESULT_STEP3_ID = cvar.SERIALIZATION_SVD_DISTRIBUTED_PARTIAL_RESULT_STEP3_ID
SERIALIZATION_RELU_RESULT_ID = cvar.SERIALIZATION_RELU_RESULT_ID
SERIALIZATION_SORTING_RESULT_ID = cvar.SERIALIZATION_SORTING_RESULT_ID
SERIALIZATION_SOFTMAX_RESULT_ID = cvar.SERIALIZATION_SOFTMAX_RESULT_ID
SERIALIZATION_LOGISTIC_RESULT_ID = cvar.SERIALIZATION_LOGISTIC_RESULT_ID
SERIALIZATION_TANH_RESULT_ID = cvar.SERIALIZATION_TANH_RESULT_ID
SERIALIZATION_SMOOTHRELU_RESULT_ID = cvar.SERIALIZATION_SMOOTHRELU_RESULT_ID
SERIALIZATION_ABS_RESULT_ID = cvar.SERIALIZATION_ABS_RESULT_ID
SERIALIZATION_OBJECTIVE_FUNCTION_RESULT_ID = cvar.SERIALIZATION_OBJECTIVE_FUNCTION_RESULT_ID
SERIALIZATION_ITERATIVE_SOLVER_RESULT_ID = cvar.SERIALIZATION_ITERATIVE_SOLVER_RESULT_ID
SERIALIZATION_ADAGRAD_RESULT_ID = cvar.SERIALIZATION_ADAGRAD_RESULT_ID
SERIALIZATION_LBFGS_RESULT_ID = cvar.SERIALIZATION_LBFGS_RESULT_ID
SERIALIZATION_SGD_RESULT_ID = cvar.SERIALIZATION_SGD_RESULT_ID
SERIALIZATION_NORMALIZATION_ZSCORE_RESULT_ID = cvar.SERIALIZATION_NORMALIZATION_ZSCORE_RESULT_ID
SERIALIZATION_NORMALIZATION_MINMAX_RESULT_ID = cvar.SERIALIZATION_NORMALIZATION_MINMAX_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_TRAINING_MODEL_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_TRAINING_MODEL_ID
SERIALIZATION_NEURAL_NETWORKS_PREDICTION_MODEL_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_PREDICTION_MODEL_ID
SERIALIZATION_NEURAL_NETWORKS_NUMERIC_TABLE_WEIGHTS_AND_BIASES_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_NUMERIC_TABLE_WEIGHTS_AND_BIASES_ID
SERIALIZATION_NEURAL_NETWORKS_NUMERIC_TABLE_WEIGHTS_AND_BIASES_DERIVATIVES_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_NUMERIC_TABLE_WEIGHTS_AND_BIASES_DERIVATIVES_ID
SERIALIZATION_NEURAL_NETWORKS_TENSOR_WEIGHTS_AND_BIASES_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_TENSOR_WEIGHTS_AND_BIASES_ID
SERIALIZATION_NEURAL_NETWORKS_TENSOR_WEIGHTS_AND_BIASES_DERIVATIVES_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_TENSOR_WEIGHTS_AND_BIASES_DERIVATIVES_ID
SERIALIZATION_NEURAL_NETWORKS_TRAINING_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_TRAINING_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_TRAINING_PARTIAL_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_TRAINING_PARTIAL_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_TRAINING_DISTRIBUTED_PARTIAL_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_TRAINING_DISTRIBUTED_PARTIAL_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_PREDICTION_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_PREDICTION_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_ABS_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_ABS_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_ABS_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_ABS_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOGISTIC_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOGISTIC_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOGISTIC_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOGISTIC_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_RELU_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_RELU_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_RELU_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_RELU_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_SMOOTHRELU_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_SMOOTHRELU_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_SMOOTHRELU_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_SMOOTHRELU_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_TANH_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_TANH_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_TANH_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_TANH_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_PRELU_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_PRELU_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_PRELU_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_PRELU_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_SOFTMAX_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_SOFTMAX_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_SOFTMAX_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_SOFTMAX_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_FULLYCONNECTED_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_FULLYCONNECTED_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_FULLYCONNECTED_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_FULLYCONNECTED_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_DROPOUT_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_DROPOUT_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_DROPOUT_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_DROPOUT_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_BATCH_NORMALIZATION_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_BATCH_NORMALIZATION_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_BATCH_NORMALIZATION_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_BATCH_NORMALIZATION_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_LRN_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_LRN_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_LRN_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_LRN_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPLIT_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPLIT_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPLIT_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPLIT_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_CONVOLUTION2D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_CONVOLUTION2D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_CONVOLUTION2D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_CONVOLUTION2D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_CONCAT_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_CONCAT_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_CONCAT_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_CONCAT_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_MAXIMUM_POOLING1D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_MAXIMUM_POOLING1D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_AVERAGE_POOLING1D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_AVERAGE_POOLING1D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_MAXIMUM_POOLING1D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_MAXIMUM_POOLING1D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_AVERAGE_POOLING1D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_AVERAGE_POOLING1D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_MAXIMUM_POOLING2D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_MAXIMUM_POOLING2D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_AVERAGE_POOLING2D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_AVERAGE_POOLING2D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_MAXIMUM_POOLING2D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_MAXIMUM_POOLING2D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_AVERAGE_POOLING2D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_AVERAGE_POOLING2D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_MAXIMUM_POOLING3D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_MAXIMUM_POOLING3D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_AVERAGE_POOLING3D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_AVERAGE_POOLING3D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_MAXIMUM_POOLING3D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_MAXIMUM_POOLING3D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_AVERAGE_POOLING3D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_AVERAGE_POOLING3D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOSS_SOFTMAX_CROSS_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOSS_SOFTMAX_CROSS_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOSS_SOFTMAX_CROSS_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOSS_SOFTMAX_CROSS_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_STOCHASTIC_POOLING2D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_STOCHASTIC_POOLING2D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_STOCHASTIC_POOLING2D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_STOCHASTIC_POOLING2D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOCALLYCONNECTED2D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOCALLYCONNECTED2D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOCALLYCONNECTED2D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOCALLYCONNECTED2D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_LCN_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_LCN_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_LCN_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_LCN_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPATIAL_AVERAGE_POOLING2D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPATIAL_AVERAGE_POOLING2D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPATIAL_AVERAGE_POOLING2D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPATIAL_AVERAGE_POOLING2D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPATIAL_MAXIMUM_POOLING2D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPATIAL_MAXIMUM_POOLING2D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPATIAL_MAXIMUM_POOLING2D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPATIAL_MAXIMUM_POOLING2D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPATIAL_STOCHASTIC_POOLING2D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPATIAL_STOCHASTIC_POOLING2D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPATIAL_STOCHASTIC_POOLING2D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_SPATIAL_STOCHASTIC_POOLING2D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_TRANSPOSED_CONV2D_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_TRANSPOSED_CONV2D_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_TRANSPOSED_CONV2D_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_TRANSPOSED_CONV2D_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOSS_LOGISTIC_CROSS_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOSS_LOGISTIC_CROSS_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOSS_LOGISTIC_CROSS_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_LOSS_LOGISTIC_CROSS_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_RESHAPE_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_RESHAPE_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_RESHAPE_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_RESHAPE_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_ELTWISE_SUM_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_ELTWISE_SUM_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_ELTWISE_SUM_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_ELTWISE_SUM_BACKWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_ELU_FORWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_ELU_FORWARD_RESULT_ID
SERIALIZATION_NEURAL_NETWORKS_LAYERS_ELU_BACKWARD_RESULT_ID = cvar.SERIALIZATION_NEURAL_NETWORKS_LAYERS_ELU_BACKWARD_RESULT_ID
SERIALIZATION_RIDGE_REGRESSION_MODELNORMEQ_ID = cvar.SERIALIZATION_RIDGE_REGRESSION_MODELNORMEQ_ID
SERIALIZATION_RIDGE_REGRESSION_PARTIAL_RESULT_ID = cvar.SERIALIZATION_RIDGE_REGRESSION_PARTIAL_RESULT_ID
SERIALIZATION_RIDGE_REGRESSION_TRAINING_RESULT_ID = cvar.SERIALIZATION_RIDGE_REGRESSION_TRAINING_RESULT_ID
SERIALIZATION_RIDGE_REGRESSION_PREDICTION_RESULT_ID = cvar.SERIALIZATION_RIDGE_REGRESSION_PREDICTION_RESULT_ID
SERIALIZATION_K_NEAREST_NEIGHBOR_MODEL_ID = cvar.SERIALIZATION_K_NEAREST_NEIGHBOR_MODEL_ID
SERIALIZATION_K_NEAREST_NEIGHBOR_TRAINING_RESULT_ID = cvar.SERIALIZATION_K_NEAREST_NEIGHBOR_TRAINING_RESULT_ID
SERIALIZATION_DECISION_FOREST_CLASSIFICATION_MODEL_ID = cvar.SERIALIZATION_DECISION_FOREST_CLASSIFICATION_MODEL_ID
SERIALIZATION_DECISION_FOREST_CLASSIFICATION_TRAINING_RESULT_ID = cvar.SERIALIZATION_DECISION_FOREST_CLASSIFICATION_TRAINING_RESULT_ID
SERIALIZATION_DECISION_FOREST_CLASSIFICATION_PREDICTION_RESULT_ID = cvar.SERIALIZATION_DECISION_FOREST_CLASSIFICATION_PREDICTION_RESULT_ID
SERIALIZATION_DECISION_FOREST_REGRESSION_MODEL_ID = cvar.SERIALIZATION_DECISION_FOREST_REGRESSION_MODEL_ID
SERIALIZATION_DECISION_FOREST_REGRESSION_TRAINING_RESULT_ID = cvar.SERIALIZATION_DECISION_FOREST_REGRESSION_TRAINING_RESULT_ID
SERIALIZATION_DECISION_FOREST_REGRESSION_PREDICTION_RESULT_ID = cvar.SERIALIZATION_DECISION_FOREST_REGRESSION_PREDICTION_RESULT_ID
SERIALIZATION_GBT_CLASSIFICATION_MODEL_ID = cvar.SERIALIZATION_GBT_CLASSIFICATION_MODEL_ID
SERIALIZATION_GBT_CLASSIFICATION_TRAINING_RESULT_ID = cvar.SERIALIZATION_GBT_CLASSIFICATION_TRAINING_RESULT_ID
SERIALIZATION_GBT_CLASSIFICATION_PREDICTION_RESULT_ID = cvar.SERIALIZATION_GBT_CLASSIFICATION_PREDICTION_RESULT_ID
SERIALIZATION_GBT_REGRESSION_MODEL_ID = cvar.SERIALIZATION_GBT_REGRESSION_MODEL_ID
SERIALIZATION_GBT_REGRESSION_TRAINING_RESULT_ID = cvar.SERIALIZATION_GBT_REGRESSION_TRAINING_RESULT_ID
SERIALIZATION_GBT_REGRESSION_PREDICTION_RESULT_ID = cvar.SERIALIZATION_GBT_REGRESSION_PREDICTION_RESULT_ID
SERIALIZATION_DECISION_TREE_CLASSIFICATION_MODEL_ID = cvar.SERIALIZATION_DECISION_TREE_CLASSIFICATION_MODEL_ID
SERIALIZATION_DECISION_TREE_CLASSIFICATION_TRAINING_RESULT_ID = cvar.SERIALIZATION_DECISION_TREE_CLASSIFICATION_TRAINING_RESULT_ID
SERIALIZATION_DECISION_TREE_REGRESSION_MODEL_ID = cvar.SERIALIZATION_DECISION_TREE_REGRESSION_MODEL_ID
SERIALIZATION_DECISION_TREE_REGRESSION_TRAINING_RESULT_ID = cvar.SERIALIZATION_DECISION_TREE_REGRESSION_TRAINING_RESULT_ID
SERIALIZATION_DECISION_TREE_REGRESSION_PREDICTION_RESULT_ID = cvar.SERIALIZATION_DECISION_TREE_REGRESSION_PREDICTION_RESULT_ID
SERIALIZATION_REGRESSION_TRAINING_RESULT_ID = cvar.SERIALIZATION_REGRESSION_TRAINING_RESULT_ID
SERIALIZATION_REGRESSION_PREDICTION_RESULT_ID = cvar.SERIALIZATION_REGRESSION_PREDICTION_RESULT_ID
SERIALIZATION_LM_TRAINING_RESULT_ID = cvar.SERIALIZATION_LM_TRAINING_RESULT_ID
SERIALIZATION_LM_PREDICTION_RESULT_ID = cvar.SERIALIZATION_LM_PREDICTION_RESULT_ID

from numpy import float64, float32, intc


# This file is compatible with both classic and new-style classes.


