# Copyright 2014-2018 Intel Corporation.
#
# This software and the related documents are Intel copyrighted  materials,  and
# your use of  them is  governed by the  express license  under which  they were
# provided to you (License).  Unless the License provides otherwise, you may not
# use, modify, copy, publish, distribute,  disclose or transmit this software or
# the related documents without Intel's prior written permission.
#
# This software and the related documents  are provided as  is,  with no express
# or implied  warranties,  other  than those  that are  expressly stated  in the
# License.



from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_training6', [dirname(__file__)])
        except ImportError:
            import _training6
            return _training6
        if fp is not None:
            try:
                _mod = imp.load_module('_training6', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _training6 = swig_import_helper()
    del swig_import_helper
else:
    import _training6
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


import daal.algorithms.decision_forest
import daal.algorithms
import daal.data_management
import daal
import daal.services
import daal.data_management.data_feature_utils
import daal.algorithms.engines.mt19937
import daal.algorithms.engines

_training6.none_swigconstant(_training6)
none = _training6.none

_training6.MDI_swigconstant(_training6)
MDI = _training6.MDI

_training6.MDA_Raw_swigconstant(_training6)
MDA_Raw = _training6.MDA_Raw

_training6.MDA_Scaled_swigconstant(_training6)
MDA_Scaled = _training6.MDA_Scaled

_training6.computeOutOfBagError_swigconstant(_training6)
computeOutOfBagError = _training6.computeOutOfBagError

_training6.computeOutOfBagErrorPerObservation_swigconstant(_training6)
computeOutOfBagErrorPerObservation = _training6.computeOutOfBagErrorPerObservation
class Parameter(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parameter, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Parameter, name)
    __repr__ = _swig_repr

    def __init__(self):
        this = _training6.new_Parameter()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_setmethods__["nTrees"] = _training6.Parameter_nTrees_set
    __swig_getmethods__["nTrees"] = _training6.Parameter_nTrees_get
    if _newclass:
        nTrees = _swig_property(_training6.Parameter_nTrees_get, _training6.Parameter_nTrees_set)
    __swig_setmethods__["observationsPerTreeFraction"] = _training6.Parameter_observationsPerTreeFraction_set
    __swig_getmethods__["observationsPerTreeFraction"] = _training6.Parameter_observationsPerTreeFraction_get
    if _newclass:
        observationsPerTreeFraction = _swig_property(_training6.Parameter_observationsPerTreeFraction_get, _training6.Parameter_observationsPerTreeFraction_set)
    __swig_setmethods__["featuresPerNode"] = _training6.Parameter_featuresPerNode_set
    __swig_getmethods__["featuresPerNode"] = _training6.Parameter_featuresPerNode_get
    if _newclass:
        featuresPerNode = _swig_property(_training6.Parameter_featuresPerNode_get, _training6.Parameter_featuresPerNode_set)
    __swig_setmethods__["maxTreeDepth"] = _training6.Parameter_maxTreeDepth_set
    __swig_getmethods__["maxTreeDepth"] = _training6.Parameter_maxTreeDepth_get
    if _newclass:
        maxTreeDepth = _swig_property(_training6.Parameter_maxTreeDepth_get, _training6.Parameter_maxTreeDepth_set)
    __swig_setmethods__["minObservationsInLeafNode"] = _training6.Parameter_minObservationsInLeafNode_set
    __swig_getmethods__["minObservationsInLeafNode"] = _training6.Parameter_minObservationsInLeafNode_get
    if _newclass:
        minObservationsInLeafNode = _swig_property(_training6.Parameter_minObservationsInLeafNode_get, _training6.Parameter_minObservationsInLeafNode_set)
    __swig_setmethods__["seed"] = _training6.Parameter_seed_set
    __swig_getmethods__["seed"] = _training6.Parameter_seed_get
    if _newclass:
        seed = _swig_property(_training6.Parameter_seed_get, _training6.Parameter_seed_set)
    __swig_setmethods__["engine"] = _training6.Parameter_engine_set
    __swig_getmethods__["engine"] = _training6.Parameter_engine_get
    if _newclass:
        engine = _swig_property(_training6.Parameter_engine_get, _training6.Parameter_engine_set)
    __swig_setmethods__["impurityThreshold"] = _training6.Parameter_impurityThreshold_set
    __swig_getmethods__["impurityThreshold"] = _training6.Parameter_impurityThreshold_get
    if _newclass:
        impurityThreshold = _swig_property(_training6.Parameter_impurityThreshold_get, _training6.Parameter_impurityThreshold_set)
    __swig_setmethods__["varImportance"] = _training6.Parameter_varImportance_set
    __swig_getmethods__["varImportance"] = _training6.Parameter_varImportance_get
    if _newclass:
        varImportance = _swig_property(_training6.Parameter_varImportance_get, _training6.Parameter_varImportance_set)
    __swig_setmethods__["resultsToCompute"] = _training6.Parameter_resultsToCompute_set
    __swig_getmethods__["resultsToCompute"] = _training6.Parameter_resultsToCompute_get
    if _newclass:
        resultsToCompute = _swig_property(_training6.Parameter_resultsToCompute_get, _training6.Parameter_resultsToCompute_set)
    __swig_setmethods__["memorySavingMode"] = _training6.Parameter_memorySavingMode_set
    __swig_getmethods__["memorySavingMode"] = _training6.Parameter_memorySavingMode_get
    if _newclass:
        memorySavingMode = _swig_property(_training6.Parameter_memorySavingMode_get, _training6.Parameter_memorySavingMode_set)
    __swig_setmethods__["bootstrap"] = _training6.Parameter_bootstrap_set
    __swig_getmethods__["bootstrap"] = _training6.Parameter_bootstrap_get
    if _newclass:
        bootstrap = _swig_property(_training6.Parameter_bootstrap_get, _training6.Parameter_bootstrap_set)
    __swig_destroy__ = _training6.delete_Parameter
    __del__ = lambda self: None
Parameter_swigregister = _training6.Parameter_swigregister
Parameter_swigregister(Parameter)

from numpy import float64, float32, intc


# This file is compatible with both classic and new-style classes.


