# Copyright 2014-2018 Intel Corporation.
#
# This software and the related documents are Intel copyrighted  materials,  and
# your use of  them is  governed by the  express license  under which  they were
# provided to you (License).  Unless the License provides otherwise, you may not
# use, modify, copy, publish, distribute,  disclose or transmit this software or
# the related documents without Intel's prior written permission.
#
# This software and the related documents  are provided as  is,  with no express
# or implied  warranties,  other  than those  that are  expressly stated  in the
# License.



from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_distributions', [dirname(__file__)])
        except ImportError:
            import _distributions
            return _distributions
        if fp is not None:
            try:
                _mod = imp.load_module('_distributions', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _distributions = swig_import_helper()
    del swig_import_helper
else:
    import _distributions
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


import daal.algorithms.engines
import daal.algorithms
import daal.data_management
import daal
import daal.services
import daal.data_management.data_feature_utils

_distributions.tableToFill_swigconstant(_distributions)
tableToFill = _distributions.tableToFill

_distributions.randomNumbers_swigconstant(_distributions)
randomNumbers = _distributions.randomNumbers
class ParameterBase(daal.algorithms.Parameter):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, ParameterBase, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, ParameterBase, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _distributions.new_ParameterBase(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _distributions.delete_ParameterBase
    __del__ = lambda self: None
    __swig_setmethods__["engine"] = _distributions.ParameterBase_engine_set
    __swig_getmethods__["engine"] = _distributions.ParameterBase_engine_get
    if _newclass:
        engine = _swig_property(_distributions.ParameterBase_engine_get, _distributions.ParameterBase_engine_set)
ParameterBase_swigregister = _distributions.ParameterBase_swigregister
ParameterBase_swigregister(ParameterBase)

class Input(daal.algorithms.Input):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Input, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Input, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _distributions.new_Input(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _distributions.delete_Input
    __del__ = lambda self: None

    def get(self, id):
        return _distributions.Input_get(self, id)

    def set(self, id, ptr):
        return _distributions.Input_set(self, id, ptr)

    def check(self, par, method):
        return _distributions.Input_check(self, par, method)
Input_swigregister = _distributions.Input_swigregister
Input_swigregister(Input)

class Result(daal.algorithms.Result):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Result, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Result, name)
    __repr__ = _swig_repr

    def __init__(self):
        this = _distributions.new_Result()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _distributions.delete_Result
    __del__ = lambda self: None

    def get(self, id):
        return _distributions.Result_get(self, id)

    def set(self, id, ptr):
        return _distributions.Result_set(self, id, ptr)

    def check(self, input, parameter, method):
        return _distributions.Result_check(self, input, parameter, method)

    def allocate_Float64(self, input, par, method):
        r"""
    This function is specialized for float64"""
        return _distributions.Result_allocate_Float64(self, input, par, method)


    def allocate_Float32(self, input, par, method):
        r"""
    This function is specialized for float32"""
        return _distributions.Result_allocate_Float32(self, input, par, method)

Result_swigregister = _distributions.Result_swigregister
Result_swigregister(Result)

class BatchBase(daal.algorithms.Analysis_Batch):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, BatchBase, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, BatchBase, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _distributions.BatchBase_input_set
    __swig_getmethods__["input"] = _distributions.BatchBase_input_get
    if _newclass:
        input = _swig_property(_distributions.BatchBase_input_get, _distributions.BatchBase_input_set)
    __swig_destroy__ = _distributions.delete_BatchBase
    __del__ = lambda self: None
BatchBase_swigregister = _distributions.BatchBase_swigregister
BatchBase_swigregister(BatchBase)

from numpy import float64, float32, intc


# This file is compatible with both classic and new-style classes.


