# Copyright 2014-2018 Intel Corporation.
#
# This software and the related documents are Intel copyrighted  materials,  and
# your use of  them is  governed by the  express license  under which  they were
# provided to you (License).  Unless the License provides otherwise, you may not
# use, modify, copy, publish, distribute,  disclose or transmit this software or
# the related documents without Intel's prior written permission.
#
# This software and the related documents  are provided as  is,  with no express
# or implied  warranties,  other  than those  that are  expressly stated  in the
# License.



from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_training10', [dirname(__file__)])
        except ImportError:
            import _training10
            return _training10
        if fp is not None:
            try:
                _mod = imp.load_module('_training10', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _training10 = swig_import_helper()
    del swig_import_helper
else:
    import _training10
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


import daal.algorithms.gbt.regression
import daal.algorithms.gbt
import daal.algorithms
import daal.data_management
import daal
import daal.services
import daal.data_management.data_feature_utils
import daal.algorithms.regression
import daal.algorithms.gbt.training
import daal.algorithms.engines.mt19937
import daal.algorithms.engines
import daal.algorithms.regression.training

_training10.xboost_swigconstant(_training10)
xboost = _training10.xboost

_training10.defaultDense_swigconstant(_training10)
defaultDense = _training10.defaultDense

_training10.squared_swigconstant(_training10)
squared = _training10.squared

_training10.custom_swigconstant(_training10)
custom = _training10.custom

_training10.data_swigconstant(_training10)
data = _training10.data

_training10.dependentVariable_swigconstant(_training10)
dependentVariable = _training10.dependentVariable

_training10.lastInputId_swigconstant(_training10)
lastInputId = _training10.lastInputId

_training10.model_swigconstant(_training10)
model = _training10.model

_training10.lastResultId_swigconstant(_training10)
lastResultId = _training10.lastResultId
class Parameter(daal.algorithms.Parameter, daal.algorithms.gbt.training.Parameter):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Parameter, daal.algorithms.gbt.training.Parameter]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parameter, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Parameter, daal.algorithms.gbt.training.Parameter]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Parameter, name)
    __repr__ = _swig_repr

    def __init__(self):
        this = _training10.new_Parameter()
        try:
            self.this.append(this)
        except:
            self.this = this

    def check(self):
        return _training10.Parameter_check(self)
    __swig_setmethods__["loss"] = _training10.Parameter_loss_set
    __swig_getmethods__["loss"] = _training10.Parameter_loss_get
    if _newclass:
        loss = _swig_property(_training10.Parameter_loss_get, _training10.Parameter_loss_set)
    __swig_destroy__ = _training10.delete_Parameter
    __del__ = lambda self: None
Parameter_swigregister = _training10.Parameter_swigregister
Parameter_swigregister(Parameter)

class Input(daal.algorithms.regression.training.Input):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.regression.training.Input]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Input, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.regression.training.Input]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Input, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _training10.new_Input(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _training10.delete_Input
    __del__ = lambda self: None

    def get(self, id):
        return _training10.Input_get(self, id)

    def set(self, id, value):
        return _training10.Input_set(self, id, value)

    def check(self, par, method):
        return _training10.Input_check(self, par, method)
Input_swigregister = _training10.Input_swigregister
Input_swigregister(Input)

class Result(daal.algorithms.regression.training.Result):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.regression.training.Result]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Result, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.regression.training.Result]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Result, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _training10.Result_serializationTag
    if _newclass:
        serializationTag = staticmethod(_training10.Result_serializationTag)

    def getSerializationTag(self):
        return _training10.Result_getSerializationTag(self)

    def __init__(self):
        this = _training10.new_Result()
        try:
            self.this.append(this)
        except:
            self.this = this

    def get(self, id):
        return _training10.Result_get(self, id)

    def set(self, id, value):
        return _training10.Result_set(self, id, value)

    def check(self, input, par, method):
        return _training10.Result_check(self, input, par, method)

    def allocate_Float64(self, input, parameter, method):
        r"""
    This function is specialized for float64"""
        return _training10.Result_allocate_Float64(self, input, parameter, method)


    def allocate_Float32(self, input, parameter, method):
        r"""
    This function is specialized for float32"""
        return _training10.Result_allocate_Float32(self, input, parameter, method)

    __swig_destroy__ = _training10.delete_Result
    __del__ = lambda self: None
Result_swigregister = _training10.Result_swigregister
Result_swigregister(Result)

def Result_serializationTag():
    return _training10.Result_serializationTag()
Result_serializationTag = _training10.Result_serializationTag

class Batch_Float64Xboost(daal.algorithms.regression.training.Batch):
    r"""
    This class is an alias of Batch()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.regression.training.Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float64Xboost, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.regression.training.Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float64Xboost, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _training10.Batch_Float64Xboost_input_set
    __swig_getmethods__["input"] = _training10.Batch_Float64Xboost_input_get
    if _newclass:
        input = _swig_property(_training10.Batch_Float64Xboost_input_get, _training10.Batch_Float64Xboost_input_set)

    def __init__(self, *args):
        this = _training10.new_Batch_Float64Xboost(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _training10.delete_Batch_Float64Xboost
    __del__ = lambda self: None

    def parameter(self, *args):
        return _training10.Batch_Float64Xboost_parameter(self, *args)

    def getInput(self):
        return _training10.Batch_Float64Xboost_getInput(self)

    def getMethod(self):
        return _training10.Batch_Float64Xboost_getMethod(self)

    def getResult(self):
        return _training10.Batch_Float64Xboost_getResult(self)

    def clone(self):
        return _training10.Batch_Float64Xboost_clone(self)

    def compute(self):
        return _training10.Batch_Float64Xboost_compute(self)
Batch_Float64Xboost_swigregister = _training10.Batch_Float64Xboost_swigregister
Batch_Float64Xboost_swigregister(Batch_Float64Xboost)

class Batch_Float32Xboost(daal.algorithms.regression.training.Batch):
    r"""
    This class is an alias of Batch()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.regression.training.Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float32Xboost, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.regression.training.Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float32Xboost, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _training10.Batch_Float32Xboost_input_set
    __swig_getmethods__["input"] = _training10.Batch_Float32Xboost_input_get
    if _newclass:
        input = _swig_property(_training10.Batch_Float32Xboost_input_get, _training10.Batch_Float32Xboost_input_set)

    def __init__(self, *args):
        this = _training10.new_Batch_Float32Xboost(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _training10.delete_Batch_Float32Xboost
    __del__ = lambda self: None

    def parameter(self, *args):
        return _training10.Batch_Float32Xboost_parameter(self, *args)

    def getInput(self):
        return _training10.Batch_Float32Xboost_getInput(self)

    def getMethod(self):
        return _training10.Batch_Float32Xboost_getMethod(self)

    def getResult(self):
        return _training10.Batch_Float32Xboost_getResult(self)

    def clone(self):
        return _training10.Batch_Float32Xboost_clone(self)

    def compute(self):
        return _training10.Batch_Float32Xboost_compute(self)
Batch_Float32Xboost_swigregister = _training10.Batch_Float32Xboost_swigregister
Batch_Float32Xboost_swigregister(Batch_Float32Xboost)

from numpy import float64, float32, intc

class Batch(object):
    r"""Factory class for different types of Batch."""
    def __new__(cls,
                *args, **kwargs):
        if 'fptype' not in kwargs or kwargs['fptype'] == float64:
            if 'method' not in kwargs or kwargs['method'] == xboost:
                return Batch_Float64Xboost(*args)
        if 'fptype' in kwargs and kwargs['fptype'] == float32:
            if 'method' not in kwargs or kwargs['method'] == xboost:
                return Batch_Float32Xboost(*args)

        raise RuntimeError("No appropriate constructor found for Batch")


# This file is compatible with both classic and new-style classes.


