# Copyright 2014-2018 Intel Corporation.
#
# This software and the related documents are Intel copyrighted  materials,  and
# your use of  them is  governed by the  express license  under which  they were
# provided to you (License).  Unless the License provides otherwise, you may not
# use, modify, copy, publish, distribute,  disclose or transmit this software or
# the related documents without Intel's prior written permission.
#
# This software and the related documents  are provided as  is,  with no express
# or implied  warranties,  other  than those  that are  expressly stated  in the
# License.



from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_forward10', [dirname(__file__)])
        except ImportError:
            import _forward10
            return _forward10
        if fp is not None:
            try:
                _mod = imp.load_module('_forward10', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _forward10 = swig_import_helper()
    del swig_import_helper
else:
    import _forward10
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


import daal.algorithms.neural_networks.layers
import daal.algorithms.neural_networks.initializers
import daal.algorithms.neural_networks
import daal.algorithms
import daal.data_management
import daal
import daal.services
import daal.data_management.data_feature_utils
import daal.algorithms.neural_networks.layers.backward
import daal.algorithms.engines.mt19937
import daal.algorithms.engines

_forward10.data_swigconstant(_forward10)
data = _forward10.data

_forward10.weights_swigconstant(_forward10)
weights = _forward10.weights

_forward10.biases_swigconstant(_forward10)
biases = _forward10.biases

_forward10.lastInputId_swigconstant(_forward10)
lastInputId = _forward10.lastInputId

_forward10.inputLayerData_swigconstant(_forward10)
inputLayerData = _forward10.inputLayerData

_forward10.lastInputLayerDataId_swigconstant(_forward10)
lastInputLayerDataId = _forward10.lastInputLayerDataId

_forward10.value_swigconstant(_forward10)
value = _forward10.value

_forward10.lastResultId_swigconstant(_forward10)
lastResultId = _forward10.lastResultId

_forward10.resultForBackward_swigconstant(_forward10)
resultForBackward = _forward10.resultForBackward

_forward10.lastResultLayerDataId_swigconstant(_forward10)
lastResultLayerDataId = _forward10.lastResultLayerDataId
class InputIface(daal.algorithms.Input):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, InputIface, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, InputIface, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _forward10.new_InputIface(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _forward10.delete_InputIface
    __del__ = lambda self: None
InputIface_swigregister = _forward10.InputIface_swigregister
InputIface_swigregister(InputIface)

class Input(InputIface):
    __swig_setmethods__ = {}
    for _s in [InputIface]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Input, name, value)
    __swig_getmethods__ = {}
    for _s in [InputIface]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Input, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _forward10.new_Input(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _forward10.delete_Input
    __del__ = lambda self: None

    def getInput(self, id):
        return _forward10.Input_getInput(self, id)

    def setInput(self, id, ptr):
        return _forward10.Input_setInput(self, id, ptr)

    def getInputLayerData(self, id):
        return _forward10.Input_getInputLayerData(self, id)

    def setInputLayerData(self, id, ptr):
        return _forward10.Input_setInputLayerData(self, id, ptr)

    def check(self, par, method):
        return _forward10.Input_check(self, par, method)

    def getLayout(self):
        return _forward10.Input_getLayout(self)

    def getWeightsSizes(self, parameter):
        return _forward10.Input_getWeightsSizes(self, parameter)

    def getBiasesSizes(self, parameter):
        return _forward10.Input_getBiasesSizes(self, parameter)

    def addData(self, dataTensor, index):
        return _forward10.Input_addData(self, dataTensor, index)

    def eraseInputData(self):
        return _forward10.Input_eraseInputData(self)
Input_swigregister = _forward10.Input_swigregister
Input_swigregister(Input)

class Result(daal.algorithms.Result):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Result, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Result, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _forward10.delete_Result
    __del__ = lambda self: None

    def getValueSize(self, *args):
        return _forward10.Result_getValueSize(self, *args)

    def getValueCollectionSize(self, inputSize, par, method):
        return _forward10.Result_getValueCollectionSize(self, inputSize, par, method)

    def getResult(self, id):
        return _forward10.Result_getResult(self, id)

    def getResultLayerData(self, id):
        return _forward10.Result_getResultLayerData(self, id)

    def setResult(self, id, ptr):
        return _forward10.Result_setResult(self, id, ptr)

    def setResultLayerData(self, id, ptr):
        return _forward10.Result_setResultLayerData(self, id, ptr)

    def getSerializationTag(self):
        return _forward10.Result_getSerializationTag(self)

    def check(self, input, parameter, method):
        return _forward10.Result_check(self, input, parameter, method)

    def getLayout(self):
        return _forward10.Result_getLayout(self)

    def setResultForBackward(self, input):
        return _forward10.Result_setResultForBackward(self, input)

    def getValue(self, index):
        return _forward10.Result_getValue(self, index)

    def allocate_Float64(self, input, par, method):
        r"""
    This function is specialized for float64"""
        return _forward10.Result_allocate_Float64(self, input, par, method)


    def allocate_Float32(self, input, par, method):
        r"""
    This function is specialized for float32"""
        return _forward10.Result_allocate_Float32(self, input, par, method)

Result_swigregister = _forward10.Result_swigregister
Result_swigregister(Result)

class LayerDescriptor(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LayerDescriptor, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LayerDescriptor, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _forward10.new_LayerDescriptor(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def index(self):
        return _forward10.LayerDescriptor_index(self)

    def addNext(self, index):
        return _forward10.LayerDescriptor_addNext(self, index)

    def layer(self):
        return _forward10.LayerDescriptor_layer(self)

    def nextLayers(self):
        return _forward10.LayerDescriptor_nextLayers(self)
    __swig_destroy__ = _forward10.delete_LayerDescriptor
    __del__ = lambda self: None
LayerDescriptor_swigregister = _forward10.LayerDescriptor_swigregister
LayerDescriptor_swigregister(LayerDescriptor)

class LayerContainerIfaceImpl(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, LayerContainerIfaceImpl, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, LayerContainerIfaceImpl, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr

    def setupCompute(self):
        return _forward10.LayerContainerIfaceImpl_setupCompute(self)

    def resetCompute(self):
        return _forward10.LayerContainerIfaceImpl_resetCompute(self)

    def allocateInput(self):
        return _forward10.LayerContainerIfaceImpl_allocateInput(self)

    def initializeInput(self):
        return _forward10.LayerContainerIfaceImpl_initializeInput(self)
    __swig_destroy__ = _forward10.delete_LayerContainerIfaceImpl
    __del__ = lambda self: None
LayerContainerIfaceImpl_swigregister = _forward10.LayerContainerIfaceImpl_swigregister
LayerContainerIfaceImpl_swigregister(LayerContainerIfaceImpl)

class LayerIface(daal.algorithms.Analysis_Batch):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LayerIface, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, LayerIface, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _forward10.delete_LayerIface
    __del__ = lambda self: None

    def getLayerResult(self):
        return _forward10.LayerIface_getLayerResult(self)

    def getLayerInput(self):
        return _forward10.LayerIface_getLayerInput(self)

    def getLayerParameter(self):
        return _forward10.LayerIface_getLayerParameter(self)

    def clone(self):
        return _forward10.LayerIface_clone(self)

    def allocateResult(self):
        return _forward10.LayerIface_allocateResult(self)

    def allocateInput(self):
        return _forward10.LayerIface_allocateInput(self)

    def initializeInput(self):
        return _forward10.LayerIface_initializeInput(self)

    def addInput(self, result, resultIndex, inputIndex):
        return _forward10.LayerIface_addInput(self, result, resultIndex, inputIndex)

    def getLayerForPrediction(self):
        return _forward10.LayerIface_getLayerForPrediction(self)
LayerIface_swigregister = _forward10.LayerIface_swigregister
LayerIface_swigregister(LayerIface)

class LayerIfaceImpl(LayerIface):
    __swig_setmethods__ = {}
    for _s in [LayerIface]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LayerIfaceImpl, name, value)
    __swig_getmethods__ = {}
    for _s in [LayerIface]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, LayerIfaceImpl, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _forward10.delete_LayerIfaceImpl
    __del__ = lambda self: None

    def allocateInput(self):
        return _forward10.LayerIfaceImpl_allocateInput(self)

    def initializeInput(self):
        return _forward10.LayerIfaceImpl_initializeInput(self)

    def addInput(self, result, resultIndex, inputIndex):
        return _forward10.LayerIfaceImpl_addInput(self, result, resultIndex, inputIndex)

    def getLayerForPrediction(self):
        return _forward10.LayerIfaceImpl_getLayerForPrediction(self)
LayerIfaceImpl_swigregister = _forward10.LayerIfaceImpl_swigregister
LayerIfaceImpl_swigregister(LayerIfaceImpl)

from numpy import float64, float32, intc


# This file is compatible with both classic and new-style classes.


