# Copyright 2014-2018 Intel Corporation.
#
# This software and the related documents are Intel copyrighted  materials,  and
# your use of  them is  governed by the  express license  under which  they were
# provided to you (License).  Unless the License provides otherwise, you may not
# use, modify, copy, publish, distribute,  disclose or transmit this software or
# the related documents without Intel's prior written permission.
#
# This software and the related documents  are provided as  is,  with no express
# or implied  warranties,  other  than those  that are  expressly stated  in the
# License.



from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_objective_function', [dirname(__file__)])
        except ImportError:
            import _objective_function
            return _objective_function
        if fp is not None:
            try:
                _mod = imp.load_module('_objective_function', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _objective_function = swig_import_helper()
    del swig_import_helper
else:
    import _objective_function
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


import daal.algorithms.optimization_solver
import daal.algorithms
import daal.data_management
import daal
import daal.services
import daal.data_management.data_feature_utils

_objective_function.argument_swigconstant(_objective_function)
argument = _objective_function.argument

_objective_function.lastInputId_swigconstant(_objective_function)
lastInputId = _objective_function.lastInputId

_objective_function.gradient_swigconstant(_objective_function)
gradient = _objective_function.gradient

_objective_function.value_swigconstant(_objective_function)
value = _objective_function.value

_objective_function.hessian_swigconstant(_objective_function)
hessian = _objective_function.hessian

_objective_function.gradientIdx_swigconstant(_objective_function)
gradientIdx = _objective_function.gradientIdx

_objective_function.valueIdx_swigconstant(_objective_function)
valueIdx = _objective_function.valueIdx

_objective_function.hessianIdx_swigconstant(_objective_function)
hessianIdx = _objective_function.hessianIdx

_objective_function.lastResultId_swigconstant(_objective_function)
lastResultId = _objective_function.lastResultId
class Parameter(daal.algorithms.Parameter):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parameter, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Parameter, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _objective_function.new_Parameter(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _objective_function.delete_Parameter
    __del__ = lambda self: None
    __swig_setmethods__["resultsToCompute"] = _objective_function.Parameter_resultsToCompute_set
    __swig_getmethods__["resultsToCompute"] = _objective_function.Parameter_resultsToCompute_get
    if _newclass:
        resultsToCompute = _swig_property(_objective_function.Parameter_resultsToCompute_get, _objective_function.Parameter_resultsToCompute_set)
Parameter_swigregister = _objective_function.Parameter_swigregister
Parameter_swigregister(Parameter)

class Input(daal.algorithms.Input):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Input, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Input, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _objective_function.new_Input(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _objective_function.delete_Input
    __del__ = lambda self: None

    def set(self, id, ptr):
        return _objective_function.Input_set(self, id, ptr)

    def get(self, id):
        return _objective_function.Input_get(self, id)

    def check(self, par, method):
        return _objective_function.Input_check(self, par, method)
Input_swigregister = _objective_function.Input_swigregister
Input_swigregister(Input)

class Result(daal.algorithms.Result):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Result, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Result, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _objective_function.Result_serializationTag
    if _newclass:
        serializationTag = staticmethod(_objective_function.Result_serializationTag)

    def getSerializationTag(self):
        return _objective_function.Result_getSerializationTag(self)

    def __init__(self):
        this = _objective_function.new_Result()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _objective_function.delete_Result
    __del__ = lambda self: None

    def set(self, id, ptr):
        return _objective_function.Result_set(self, id, ptr)

    def get(self, id):
        return _objective_function.Result_get(self, id)

    def check(self, input, par, method):
        return _objective_function.Result_check(self, input, par, method)

    def allocate_Float64(self, input, parameter, method):
        r"""
    This function is specialized for float64"""
        return _objective_function.Result_allocate_Float64(self, input, parameter, method)


    def allocate_Float32(self, input, parameter, method):
        r"""
    This function is specialized for float32"""
        return _objective_function.Result_allocate_Float32(self, input, parameter, method)

Result_swigregister = _objective_function.Result_swigregister
Result_swigregister(Result)

def Result_serializationTag():
    return _objective_function.Result_serializationTag()
Result_serializationTag = _objective_function.Result_serializationTag

class Batch(daal.algorithms.Analysis_Batch):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined - class is abstract")
    __repr__ = _swig_repr
    __swig_destroy__ = _objective_function.delete_Batch
    __del__ = lambda self: None

    def getResult(self):
        return _objective_function.Batch_getResult(self)

    def setResult(self, result):
        return _objective_function.Batch_setResult(self, result)

    def clone(self):
        return _objective_function.Batch_clone(self)

    def compute(self):
        return _objective_function.Batch_compute(self)
Batch_swigregister = _objective_function.Batch_swigregister
Batch_swigregister(Batch)

from numpy import float64, float32, intc


# This file is compatible with both classic and new-style classes.


