# Copyright 2014-2018 Intel Corporation.
#
# This software and the related documents are Intel copyrighted  materials,  and
# your use of  them is  governed by the  express license  under which  they were
# provided to you (License).  Unless the License provides otherwise, you may not
# use, modify, copy, publish, distribute,  disclose or transmit this software or
# the related documents without Intel's prior written permission.
#
# This software and the related documents  are provided as  is,  with no express
# or implied  warranties,  other  than those  that are  expressly stated  in the
# License.



from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_qr', [dirname(__file__)])
        except ImportError:
            import _qr
            return _qr
        if fp is not None:
            try:
                _mod = imp.load_module('_qr', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _qr = swig_import_helper()
    del swig_import_helper
else:
    import _qr
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


import daal.algorithms
import daal.data_management
import daal
import daal.services
import daal.data_management.data_feature_utils

_qr.defaultDense_swigconstant(_qr)
defaultDense = _qr.defaultDense

_qr.data_swigconstant(_qr)
data = _qr.data

_qr.lastInputId_swigconstant(_qr)
lastInputId = _qr.lastInputId

_qr.matrixQ_swigconstant(_qr)
matrixQ = _qr.matrixQ

_qr.matrixR_swigconstant(_qr)
matrixR = _qr.matrixR

_qr.lastResultId_swigconstant(_qr)
lastResultId = _qr.lastResultId

_qr.outputOfStep1ForStep3_swigconstant(_qr)
outputOfStep1ForStep3 = _qr.outputOfStep1ForStep3

_qr.outputOfStep1ForStep2_swigconstant(_qr)
outputOfStep1ForStep2 = _qr.outputOfStep1ForStep2

_qr.lastPartialResultId_swigconstant(_qr)
lastPartialResultId = _qr.lastPartialResultId

_qr.outputOfStep2ForStep3_swigconstant(_qr)
outputOfStep2ForStep3 = _qr.outputOfStep2ForStep3

_qr.lastDistributedPartialResultCollectionId_swigconstant(_qr)
lastDistributedPartialResultCollectionId = _qr.lastDistributedPartialResultCollectionId

_qr.finalResultFromStep2Master_swigconstant(_qr)
finalResultFromStep2Master = _qr.finalResultFromStep2Master

_qr.lastDistributedPartialResultId_swigconstant(_qr)
lastDistributedPartialResultId = _qr.lastDistributedPartialResultId

_qr.finalResultFromStep3_swigconstant(_qr)
finalResultFromStep3 = _qr.finalResultFromStep3

_qr.lastDistributedPartialResultStep3Id_swigconstant(_qr)
lastDistributedPartialResultStep3Id = _qr.lastDistributedPartialResultStep3Id

_qr.inputOfStep2FromStep1_swigconstant(_qr)
inputOfStep2FromStep1 = _qr.inputOfStep2FromStep1

_qr.lastMasterInputId_swigconstant(_qr)
lastMasterInputId = _qr.lastMasterInputId

_qr.inputOfStep3FromStep1_swigconstant(_qr)
inputOfStep3FromStep1 = _qr.inputOfStep3FromStep1

_qr.inputOfStep3FromStep2_swigconstant(_qr)
inputOfStep3FromStep2 = _qr.inputOfStep3FromStep2

_qr.lastFinalizeOnLocalInputId_swigconstant(_qr)
lastFinalizeOnLocalInputId = _qr.lastFinalizeOnLocalInputId
class Input(daal.algorithms.Input):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Input, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Input, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _qr.new_Input(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _qr.delete_Input
    __del__ = lambda self: None

    def get(self, id):
        return _qr.Input_get(self, id)

    def set(self, id, value):
        return _qr.Input_set(self, id, value)

    def getNumberOfColumns(self, nFeatures):
        return _qr.Input_getNumberOfColumns(self, nFeatures)

    def getNumberOfRows(self, nRows):
        return _qr.Input_getNumberOfRows(self, nRows)

    def check(self, parameter, method):
        return _qr.Input_check(self, parameter, method)
Input_swigregister = _qr.Input_swigregister
Input_swigregister(Input)

class DistributedStep2Input(daal.algorithms.Input):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DistributedStep2Input, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, DistributedStep2Input, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _qr.new_DistributedStep2Input(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getNumberOfColumns(self, nFeatures):
        return _qr.DistributedStep2Input_getNumberOfColumns(self, nFeatures)

    def set(self, id, ptr):
        return _qr.DistributedStep2Input_set(self, id, ptr)

    def get(self, id):
        return _qr.DistributedStep2Input_get(self, id)

    def add(self, id, key, value):
        return _qr.DistributedStep2Input_add(self, id, key, value)

    def getNBlocks(self):
        return _qr.DistributedStep2Input_getNBlocks(self)

    def check(self, parameter, method):
        return _qr.DistributedStep2Input_check(self, parameter, method)
    __swig_destroy__ = _qr.delete_DistributedStep2Input
    __del__ = lambda self: None
DistributedStep2Input_swigregister = _qr.DistributedStep2Input_swigregister
DistributedStep2Input_swigregister(DistributedStep2Input)

class DistributedStep3Input(daal.algorithms.Input):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DistributedStep3Input, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, DistributedStep3Input, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _qr.new_DistributedStep3Input(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def get(self, id):
        return _qr.DistributedStep3Input_get(self, id)

    def set(self, id, value):
        return _qr.DistributedStep3Input_set(self, id, value)

    def getSizes(self, nFeatures, nVectors):
        return _qr.DistributedStep3Input_getSizes(self, nFeatures, nVectors)

    def check(self, parameter, method):
        return _qr.DistributedStep3Input_check(self, parameter, method)
    __swig_destroy__ = _qr.delete_DistributedStep3Input
    __del__ = lambda self: None
DistributedStep3Input_swigregister = _qr.DistributedStep3Input_swigregister
DistributedStep3Input_swigregister(DistributedStep3Input)

class OnlinePartialResult(daal.algorithms.PartialResult):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.PartialResult]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, OnlinePartialResult, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.PartialResult]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, OnlinePartialResult, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _qr.OnlinePartialResult_serializationTag
    if _newclass:
        serializationTag = staticmethod(_qr.OnlinePartialResult_serializationTag)

    def getSerializationTag(self):
        return _qr.OnlinePartialResult_getSerializationTag(self)

    def __init__(self):
        this = _qr.new_OnlinePartialResult()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _qr.delete_OnlinePartialResult
    __del__ = lambda self: None

    def get(self, id):
        return _qr.OnlinePartialResult_get(self, id)

    def set(self, id, value):
        return _qr.OnlinePartialResult_set(self, id, value)

    def check(self, *args):
        return _qr.OnlinePartialResult_check(self, *args)

    def getNumberOfColumns(self):
        return _qr.OnlinePartialResult_getNumberOfColumns(self)

    def getNumberOfRows(self):
        return _qr.OnlinePartialResult_getNumberOfRows(self)

    def allocate_Float64(self, input, parameter, method):
        r"""
    This function is specialized for float64"""
        return _qr.OnlinePartialResult_allocate_Float64(self, input, parameter, method)


    def allocate_Float32(self, input, parameter, method):
        r"""
    This function is specialized for float32"""
        return _qr.OnlinePartialResult_allocate_Float32(self, input, parameter, method)


    def initialize_Float64(self, input, parameter, method):
        r"""
    This function is specialized for float64"""
        return _qr.OnlinePartialResult_initialize_Float64(self, input, parameter, method)


    def initialize_Float32(self, input, parameter, method):
        r"""
    This function is specialized for float32"""
        return _qr.OnlinePartialResult_initialize_Float32(self, input, parameter, method)

OnlinePartialResult_swigregister = _qr.OnlinePartialResult_swigregister
OnlinePartialResult_swigregister(OnlinePartialResult)

def OnlinePartialResult_serializationTag():
    return _qr.OnlinePartialResult_serializationTag()
OnlinePartialResult_serializationTag = _qr.OnlinePartialResult_serializationTag

class Result(daal.algorithms.Result):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Result, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Result, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _qr.Result_serializationTag
    if _newclass:
        serializationTag = staticmethod(_qr.Result_serializationTag)

    def getSerializationTag(self):
        return _qr.Result_getSerializationTag(self)

    def __init__(self):
        this = _qr.new_Result()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _qr.delete_Result
    __del__ = lambda self: None

    def get(self, id):
        return _qr.Result_get(self, id)

    def set(self, id, value):
        return _qr.Result_set(self, id, value)

    def check(self, *args):
        return _qr.Result_check(self, *args)

    def allocate_Float64(self, *args):
        r"""
    This function is specialized for float64"""
        return _qr.Result_allocate_Float64(self, *args)


    def allocate_Float32(self, *args):
        r"""
    This function is specialized for float32"""
        return _qr.Result_allocate_Float32(self, *args)

Result_swigregister = _qr.Result_swigregister
Result_swigregister(Result)

def Result_serializationTag():
    return _qr.Result_serializationTag()
Result_serializationTag = _qr.Result_serializationTag

class DistributedPartialResult(daal.algorithms.PartialResult):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.PartialResult]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DistributedPartialResult, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.PartialResult]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, DistributedPartialResult, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _qr.DistributedPartialResult_serializationTag
    if _newclass:
        serializationTag = staticmethod(_qr.DistributedPartialResult_serializationTag)

    def getSerializationTag(self):
        return _qr.DistributedPartialResult_getSerializationTag(self)

    def __init__(self):
        this = _qr.new_DistributedPartialResult()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _qr.delete_DistributedPartialResult
    __del__ = lambda self: None

    def getResult(self, id):
        return _qr.DistributedPartialResult_getResult(self, id)

    def setCollection(self, id, value):
        return _qr.DistributedPartialResult_setCollection(self, id, value)

    def setResult(self, id, value):
        return _qr.DistributedPartialResult_setResult(self, id, value)

    def check(self, *args):
        return _qr.DistributedPartialResult_check(self, *args)

    def getCollection(self, *args):
        return _qr.DistributedPartialResult_getCollection(self, *args)

    def allocate_Float64(self, input, parameter, method):
        r"""
    This function is specialized for float64"""
        return _qr.DistributedPartialResult_allocate_Float64(self, input, parameter, method)


    def allocate_Float32(self, input, parameter, method):
        r"""
    This function is specialized for float32"""
        return _qr.DistributedPartialResult_allocate_Float32(self, input, parameter, method)

DistributedPartialResult_swigregister = _qr.DistributedPartialResult_swigregister
DistributedPartialResult_swigregister(DistributedPartialResult)

def DistributedPartialResult_serializationTag():
    return _qr.DistributedPartialResult_serializationTag()
DistributedPartialResult_serializationTag = _qr.DistributedPartialResult_serializationTag

class DistributedPartialResultStep3(daal.algorithms.PartialResult):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.PartialResult]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, DistributedPartialResultStep3, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.PartialResult]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, DistributedPartialResultStep3, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _qr.DistributedPartialResultStep3_serializationTag
    if _newclass:
        serializationTag = staticmethod(_qr.DistributedPartialResultStep3_serializationTag)

    def getSerializationTag(self):
        return _qr.DistributedPartialResultStep3_getSerializationTag(self)

    def __init__(self):
        this = _qr.new_DistributedPartialResultStep3()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _qr.delete_DistributedPartialResultStep3
    __del__ = lambda self: None

    def get(self, id):
        return _qr.DistributedPartialResultStep3_get(self, id)

    def set(self, id, value):
        return _qr.DistributedPartialResultStep3_set(self, id, value)

    def check(self, *args):
        return _qr.DistributedPartialResultStep3_check(self, *args)

    def allocate_Float64(self, input, parameter, method):
        r"""
    This function is specialized for float64"""
        return _qr.DistributedPartialResultStep3_allocate_Float64(self, input, parameter, method)


    def allocate_Float32(self, input, parameter, method):
        r"""
    This function is specialized for float32"""
        return _qr.DistributedPartialResultStep3_allocate_Float32(self, input, parameter, method)

DistributedPartialResultStep3_swigregister = _qr.DistributedPartialResultStep3_swigregister
DistributedPartialResultStep3_swigregister(DistributedPartialResultStep3)

def DistributedPartialResultStep3_serializationTag():
    return _qr.DistributedPartialResultStep3_serializationTag()
DistributedPartialResultStep3_serializationTag = _qr.DistributedPartialResultStep3_serializationTag

class Parameter(daal.algorithms.Parameter):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parameter, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Parameter, name)
    __repr__ = _swig_repr

    def __init__(self):
        this = _qr.new_Parameter()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _qr.delete_Parameter
    __del__ = lambda self: None
Parameter_swigregister = _qr.Parameter_swigregister
Parameter_swigregister(Parameter)

class Batch_Float64DefaultDense(daal.algorithms.Analysis_Batch):
    r"""
    This class is an alias of Batch()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float64DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float64DefaultDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _qr.Batch_Float64DefaultDense_input_set
    __swig_getmethods__["input"] = _qr.Batch_Float64DefaultDense_input_get
    if _newclass:
        input = _swig_property(_qr.Batch_Float64DefaultDense_input_get, _qr.Batch_Float64DefaultDense_input_set)
    __swig_setmethods__["parameter"] = _qr.Batch_Float64DefaultDense_parameter_set
    __swig_getmethods__["parameter"] = _qr.Batch_Float64DefaultDense_parameter_get
    if _newclass:
        parameter = _swig_property(_qr.Batch_Float64DefaultDense_parameter_get, _qr.Batch_Float64DefaultDense_parameter_set)

    def __init__(self, *args):
        this = _qr.new_Batch_Float64DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getMethod(self):
        return _qr.Batch_Float64DefaultDense_getMethod(self)

    def getResult(self):
        return _qr.Batch_Float64DefaultDense_getResult(self)

    def setResult(self, res):
        return _qr.Batch_Float64DefaultDense_setResult(self, res)

    def clone(self):
        return _qr.Batch_Float64DefaultDense_clone(self)

    def compute(self):
        return _qr.Batch_Float64DefaultDense_compute(self)
    __swig_destroy__ = _qr.delete_Batch_Float64DefaultDense
    __del__ = lambda self: None
Batch_Float64DefaultDense_swigregister = _qr.Batch_Float64DefaultDense_swigregister
Batch_Float64DefaultDense_swigregister(Batch_Float64DefaultDense)

class Batch_Float32DefaultDense(daal.algorithms.Analysis_Batch):
    r"""
    This class is an alias of Batch()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float32DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float32DefaultDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _qr.Batch_Float32DefaultDense_input_set
    __swig_getmethods__["input"] = _qr.Batch_Float32DefaultDense_input_get
    if _newclass:
        input = _swig_property(_qr.Batch_Float32DefaultDense_input_get, _qr.Batch_Float32DefaultDense_input_set)
    __swig_setmethods__["parameter"] = _qr.Batch_Float32DefaultDense_parameter_set
    __swig_getmethods__["parameter"] = _qr.Batch_Float32DefaultDense_parameter_get
    if _newclass:
        parameter = _swig_property(_qr.Batch_Float32DefaultDense_parameter_get, _qr.Batch_Float32DefaultDense_parameter_set)

    def __init__(self, *args):
        this = _qr.new_Batch_Float32DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getMethod(self):
        return _qr.Batch_Float32DefaultDense_getMethod(self)

    def getResult(self):
        return _qr.Batch_Float32DefaultDense_getResult(self)

    def setResult(self, res):
        return _qr.Batch_Float32DefaultDense_setResult(self, res)

    def clone(self):
        return _qr.Batch_Float32DefaultDense_clone(self)

    def compute(self):
        return _qr.Batch_Float32DefaultDense_compute(self)
    __swig_destroy__ = _qr.delete_Batch_Float32DefaultDense
    __del__ = lambda self: None
Batch_Float32DefaultDense_swigregister = _qr.Batch_Float32DefaultDense_swigregister
Batch_Float32DefaultDense_swigregister(Batch_Float32DefaultDense)

class Online_Float64DefaultDense(daal.algorithms.Analysis_Online):
    r"""
    This class is an alias of Online()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Online]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Online_Float64DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Online]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Online_Float64DefaultDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _qr.Online_Float64DefaultDense_input_set
    __swig_getmethods__["input"] = _qr.Online_Float64DefaultDense_input_get
    if _newclass:
        input = _swig_property(_qr.Online_Float64DefaultDense_input_get, _qr.Online_Float64DefaultDense_input_set)
    __swig_setmethods__["parameter"] = _qr.Online_Float64DefaultDense_parameter_set
    __swig_getmethods__["parameter"] = _qr.Online_Float64DefaultDense_parameter_get
    if _newclass:
        parameter = _swig_property(_qr.Online_Float64DefaultDense_parameter_get, _qr.Online_Float64DefaultDense_parameter_set)

    def __init__(self, *args):
        this = _qr.new_Online_Float64DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getMethod(self):
        return _qr.Online_Float64DefaultDense_getMethod(self)

    def getResult(self):
        return _qr.Online_Float64DefaultDense_getResult(self)

    def getPartialResult(self):
        return _qr.Online_Float64DefaultDense_getPartialResult(self)

    def setResult(self, res):
        return _qr.Online_Float64DefaultDense_setResult(self, res)

    def setPartialResult(self, partialResult, initFlag=False):
        return _qr.Online_Float64DefaultDense_setPartialResult(self, partialResult, initFlag)

    def clone(self):
        return _qr.Online_Float64DefaultDense_clone(self)

    def compute(self):
        return _qr.Online_Float64DefaultDense_compute(self)

    def finalizeCompute(self):
        return _qr.Online_Float64DefaultDense_finalizeCompute(self)
    __swig_destroy__ = _qr.delete_Online_Float64DefaultDense
    __del__ = lambda self: None
Online_Float64DefaultDense_swigregister = _qr.Online_Float64DefaultDense_swigregister
Online_Float64DefaultDense_swigregister(Online_Float64DefaultDense)

class Online_Float32DefaultDense(daal.algorithms.Analysis_Online):
    r"""
    This class is an alias of Online()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Online]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Online_Float32DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Online]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Online_Float32DefaultDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _qr.Online_Float32DefaultDense_input_set
    __swig_getmethods__["input"] = _qr.Online_Float32DefaultDense_input_get
    if _newclass:
        input = _swig_property(_qr.Online_Float32DefaultDense_input_get, _qr.Online_Float32DefaultDense_input_set)
    __swig_setmethods__["parameter"] = _qr.Online_Float32DefaultDense_parameter_set
    __swig_getmethods__["parameter"] = _qr.Online_Float32DefaultDense_parameter_get
    if _newclass:
        parameter = _swig_property(_qr.Online_Float32DefaultDense_parameter_get, _qr.Online_Float32DefaultDense_parameter_set)

    def __init__(self, *args):
        this = _qr.new_Online_Float32DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getMethod(self):
        return _qr.Online_Float32DefaultDense_getMethod(self)

    def getResult(self):
        return _qr.Online_Float32DefaultDense_getResult(self)

    def getPartialResult(self):
        return _qr.Online_Float32DefaultDense_getPartialResult(self)

    def setResult(self, res):
        return _qr.Online_Float32DefaultDense_setResult(self, res)

    def setPartialResult(self, partialResult, initFlag=False):
        return _qr.Online_Float32DefaultDense_setPartialResult(self, partialResult, initFlag)

    def clone(self):
        return _qr.Online_Float32DefaultDense_clone(self)

    def compute(self):
        return _qr.Online_Float32DefaultDense_compute(self)

    def finalizeCompute(self):
        return _qr.Online_Float32DefaultDense_finalizeCompute(self)
    __swig_destroy__ = _qr.delete_Online_Float32DefaultDense
    __del__ = lambda self: None
Online_Float32DefaultDense_swigregister = _qr.Online_Float32DefaultDense_swigregister
Online_Float32DefaultDense_swigregister(Online_Float32DefaultDense)

class Distributed_Step1LocalFloat64DefaultDense(Online_Float64DefaultDense):
    r"""
    This class is an alias of Distributed()
    """
    __swig_setmethods__ = {}
    for _s in [Online_Float64DefaultDense]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Distributed_Step1LocalFloat64DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [Online_Float64DefaultDense]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Distributed_Step1LocalFloat64DefaultDense, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _qr.new_Distributed_Step1LocalFloat64DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def clone(self):
        return _qr.Distributed_Step1LocalFloat64DefaultDense_clone(self)

    def compute(self):
        return _qr.Distributed_Step1LocalFloat64DefaultDense_compute(self)

    def finalizeCompute(self):
        return _qr.Distributed_Step1LocalFloat64DefaultDense_finalizeCompute(self)
    __swig_destroy__ = _qr.delete_Distributed_Step1LocalFloat64DefaultDense
    __del__ = lambda self: None
Distributed_Step1LocalFloat64DefaultDense_swigregister = _qr.Distributed_Step1LocalFloat64DefaultDense_swigregister
Distributed_Step1LocalFloat64DefaultDense_swigregister(Distributed_Step1LocalFloat64DefaultDense)

class Distributed_Step1LocalFloat32DefaultDense(Online_Float32DefaultDense):
    r"""
    This class is an alias of Distributed()
    """
    __swig_setmethods__ = {}
    for _s in [Online_Float32DefaultDense]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Distributed_Step1LocalFloat32DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [Online_Float32DefaultDense]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Distributed_Step1LocalFloat32DefaultDense, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _qr.new_Distributed_Step1LocalFloat32DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def clone(self):
        return _qr.Distributed_Step1LocalFloat32DefaultDense_clone(self)

    def compute(self):
        return _qr.Distributed_Step1LocalFloat32DefaultDense_compute(self)

    def finalizeCompute(self):
        return _qr.Distributed_Step1LocalFloat32DefaultDense_finalizeCompute(self)
    __swig_destroy__ = _qr.delete_Distributed_Step1LocalFloat32DefaultDense
    __del__ = lambda self: None
Distributed_Step1LocalFloat32DefaultDense_swigregister = _qr.Distributed_Step1LocalFloat32DefaultDense_swigregister
Distributed_Step1LocalFloat32DefaultDense_swigregister(Distributed_Step1LocalFloat32DefaultDense)

class Distributed_Step2MasterFloat64DefaultDense(daal.algorithms.Analysis_Distributed):
    r"""
    This class is an alias of Distributed()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Distributed]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Distributed_Step2MasterFloat64DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Distributed]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Distributed_Step2MasterFloat64DefaultDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _qr.Distributed_Step2MasterFloat64DefaultDense_input_set
    __swig_getmethods__["input"] = _qr.Distributed_Step2MasterFloat64DefaultDense_input_get
    if _newclass:
        input = _swig_property(_qr.Distributed_Step2MasterFloat64DefaultDense_input_get, _qr.Distributed_Step2MasterFloat64DefaultDense_input_set)
    __swig_setmethods__["parameter"] = _qr.Distributed_Step2MasterFloat64DefaultDense_parameter_set
    __swig_getmethods__["parameter"] = _qr.Distributed_Step2MasterFloat64DefaultDense_parameter_get
    if _newclass:
        parameter = _swig_property(_qr.Distributed_Step2MasterFloat64DefaultDense_parameter_get, _qr.Distributed_Step2MasterFloat64DefaultDense_parameter_set)

    def __init__(self, *args):
        this = _qr.new_Distributed_Step2MasterFloat64DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getMethod(self):
        return _qr.Distributed_Step2MasterFloat64DefaultDense_getMethod(self)

    def getResult(self):
        return _qr.Distributed_Step2MasterFloat64DefaultDense_getResult(self)

    def getPartialResult(self):
        return _qr.Distributed_Step2MasterFloat64DefaultDense_getPartialResult(self)

    def setPartialResult(self, partialRes):
        return _qr.Distributed_Step2MasterFloat64DefaultDense_setPartialResult(self, partialRes)

    def checkFinalizeComputeParams(self):
        return _qr.Distributed_Step2MasterFloat64DefaultDense_checkFinalizeComputeParams(self)

    def clone(self):
        return _qr.Distributed_Step2MasterFloat64DefaultDense_clone(self)

    def compute(self):
        return _qr.Distributed_Step2MasterFloat64DefaultDense_compute(self)

    def finalizeCompute(self):
        return _qr.Distributed_Step2MasterFloat64DefaultDense_finalizeCompute(self)
    __swig_destroy__ = _qr.delete_Distributed_Step2MasterFloat64DefaultDense
    __del__ = lambda self: None
Distributed_Step2MasterFloat64DefaultDense_swigregister = _qr.Distributed_Step2MasterFloat64DefaultDense_swigregister
Distributed_Step2MasterFloat64DefaultDense_swigregister(Distributed_Step2MasterFloat64DefaultDense)

class Distributed_Step2MasterFloat32DefaultDense(daal.algorithms.Analysis_Distributed):
    r"""
    This class is an alias of Distributed()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Distributed]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Distributed_Step2MasterFloat32DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Distributed]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Distributed_Step2MasterFloat32DefaultDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _qr.Distributed_Step2MasterFloat32DefaultDense_input_set
    __swig_getmethods__["input"] = _qr.Distributed_Step2MasterFloat32DefaultDense_input_get
    if _newclass:
        input = _swig_property(_qr.Distributed_Step2MasterFloat32DefaultDense_input_get, _qr.Distributed_Step2MasterFloat32DefaultDense_input_set)
    __swig_setmethods__["parameter"] = _qr.Distributed_Step2MasterFloat32DefaultDense_parameter_set
    __swig_getmethods__["parameter"] = _qr.Distributed_Step2MasterFloat32DefaultDense_parameter_get
    if _newclass:
        parameter = _swig_property(_qr.Distributed_Step2MasterFloat32DefaultDense_parameter_get, _qr.Distributed_Step2MasterFloat32DefaultDense_parameter_set)

    def __init__(self, *args):
        this = _qr.new_Distributed_Step2MasterFloat32DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getMethod(self):
        return _qr.Distributed_Step2MasterFloat32DefaultDense_getMethod(self)

    def getResult(self):
        return _qr.Distributed_Step2MasterFloat32DefaultDense_getResult(self)

    def getPartialResult(self):
        return _qr.Distributed_Step2MasterFloat32DefaultDense_getPartialResult(self)

    def setPartialResult(self, partialRes):
        return _qr.Distributed_Step2MasterFloat32DefaultDense_setPartialResult(self, partialRes)

    def checkFinalizeComputeParams(self):
        return _qr.Distributed_Step2MasterFloat32DefaultDense_checkFinalizeComputeParams(self)

    def clone(self):
        return _qr.Distributed_Step2MasterFloat32DefaultDense_clone(self)

    def compute(self):
        return _qr.Distributed_Step2MasterFloat32DefaultDense_compute(self)

    def finalizeCompute(self):
        return _qr.Distributed_Step2MasterFloat32DefaultDense_finalizeCompute(self)
    __swig_destroy__ = _qr.delete_Distributed_Step2MasterFloat32DefaultDense
    __del__ = lambda self: None
Distributed_Step2MasterFloat32DefaultDense_swigregister = _qr.Distributed_Step2MasterFloat32DefaultDense_swigregister
Distributed_Step2MasterFloat32DefaultDense_swigregister(Distributed_Step2MasterFloat32DefaultDense)

class Distributed_Step3LocalFloat64DefaultDense(daal.algorithms.Analysis_Distributed):
    r"""
    This class is an alias of Distributed()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Distributed]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Distributed_Step3LocalFloat64DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Distributed]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Distributed_Step3LocalFloat64DefaultDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _qr.Distributed_Step3LocalFloat64DefaultDense_input_set
    __swig_getmethods__["input"] = _qr.Distributed_Step3LocalFloat64DefaultDense_input_get
    if _newclass:
        input = _swig_property(_qr.Distributed_Step3LocalFloat64DefaultDense_input_get, _qr.Distributed_Step3LocalFloat64DefaultDense_input_set)
    __swig_setmethods__["parameter"] = _qr.Distributed_Step3LocalFloat64DefaultDense_parameter_set
    __swig_getmethods__["parameter"] = _qr.Distributed_Step3LocalFloat64DefaultDense_parameter_get
    if _newclass:
        parameter = _swig_property(_qr.Distributed_Step3LocalFloat64DefaultDense_parameter_get, _qr.Distributed_Step3LocalFloat64DefaultDense_parameter_set)

    def __init__(self, *args):
        this = _qr.new_Distributed_Step3LocalFloat64DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getMethod(self):
        return _qr.Distributed_Step3LocalFloat64DefaultDense_getMethod(self)

    def getResult(self):
        return _qr.Distributed_Step3LocalFloat64DefaultDense_getResult(self)

    def getPartialResult(self):
        return _qr.Distributed_Step3LocalFloat64DefaultDense_getPartialResult(self)

    def setPartialResult(self, partialRes):
        return _qr.Distributed_Step3LocalFloat64DefaultDense_setPartialResult(self, partialRes)

    def setResult(self, res):
        return _qr.Distributed_Step3LocalFloat64DefaultDense_setResult(self, res)

    def checkFinalizeComputeParams(self):
        return _qr.Distributed_Step3LocalFloat64DefaultDense_checkFinalizeComputeParams(self)

    def clone(self):
        return _qr.Distributed_Step3LocalFloat64DefaultDense_clone(self)

    def compute(self):
        return _qr.Distributed_Step3LocalFloat64DefaultDense_compute(self)

    def finalizeCompute(self):
        return _qr.Distributed_Step3LocalFloat64DefaultDense_finalizeCompute(self)
    __swig_destroy__ = _qr.delete_Distributed_Step3LocalFloat64DefaultDense
    __del__ = lambda self: None
Distributed_Step3LocalFloat64DefaultDense_swigregister = _qr.Distributed_Step3LocalFloat64DefaultDense_swigregister
Distributed_Step3LocalFloat64DefaultDense_swigregister(Distributed_Step3LocalFloat64DefaultDense)

class Distributed_Step3LocalFloat32DefaultDense(daal.algorithms.Analysis_Distributed):
    r"""
    This class is an alias of Distributed()
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Distributed]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Distributed_Step3LocalFloat32DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Distributed]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Distributed_Step3LocalFloat32DefaultDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _qr.Distributed_Step3LocalFloat32DefaultDense_input_set
    __swig_getmethods__["input"] = _qr.Distributed_Step3LocalFloat32DefaultDense_input_get
    if _newclass:
        input = _swig_property(_qr.Distributed_Step3LocalFloat32DefaultDense_input_get, _qr.Distributed_Step3LocalFloat32DefaultDense_input_set)
    __swig_setmethods__["parameter"] = _qr.Distributed_Step3LocalFloat32DefaultDense_parameter_set
    __swig_getmethods__["parameter"] = _qr.Distributed_Step3LocalFloat32DefaultDense_parameter_get
    if _newclass:
        parameter = _swig_property(_qr.Distributed_Step3LocalFloat32DefaultDense_parameter_get, _qr.Distributed_Step3LocalFloat32DefaultDense_parameter_set)

    def __init__(self, *args):
        this = _qr.new_Distributed_Step3LocalFloat32DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getMethod(self):
        return _qr.Distributed_Step3LocalFloat32DefaultDense_getMethod(self)

    def getResult(self):
        return _qr.Distributed_Step3LocalFloat32DefaultDense_getResult(self)

    def getPartialResult(self):
        return _qr.Distributed_Step3LocalFloat32DefaultDense_getPartialResult(self)

    def setPartialResult(self, partialRes):
        return _qr.Distributed_Step3LocalFloat32DefaultDense_setPartialResult(self, partialRes)

    def setResult(self, res):
        return _qr.Distributed_Step3LocalFloat32DefaultDense_setResult(self, res)

    def checkFinalizeComputeParams(self):
        return _qr.Distributed_Step3LocalFloat32DefaultDense_checkFinalizeComputeParams(self)

    def clone(self):
        return _qr.Distributed_Step3LocalFloat32DefaultDense_clone(self)

    def compute(self):
        return _qr.Distributed_Step3LocalFloat32DefaultDense_compute(self)

    def finalizeCompute(self):
        return _qr.Distributed_Step3LocalFloat32DefaultDense_finalizeCompute(self)
    __swig_destroy__ = _qr.delete_Distributed_Step3LocalFloat32DefaultDense
    __del__ = lambda self: None
Distributed_Step3LocalFloat32DefaultDense_swigregister = _qr.Distributed_Step3LocalFloat32DefaultDense_swigregister
Distributed_Step3LocalFloat32DefaultDense_swigregister(Distributed_Step3LocalFloat32DefaultDense)

from numpy import float64, float32, intc

class Online(object):
    r"""Factory class for different types of Online."""
    def __new__(cls,
                *args, **kwargs):
        if 'fptype' not in kwargs or kwargs['fptype'] == float64:
            if 'method' not in kwargs or kwargs['method'] == defaultDense:
                return Online_Float64DefaultDense(*args)
        if 'fptype' in kwargs and kwargs['fptype'] == float32:
            if 'method' not in kwargs or kwargs['method'] == defaultDense:
                return Online_Float32DefaultDense(*args)

        raise RuntimeError("No appropriate constructor found for Online")

class Distributed(object):
    r"""Factory class for different types of Distributed."""
    def __new__(cls,
                step,
                *args, **kwargs):
        if step == daal.step1Local:
            if 'fptype' not in kwargs or kwargs['fptype'] == float64:
                    if 'method' not in kwargs or kwargs['method'] == defaultDense:
                        return Distributed_Step1LocalFloat64DefaultDense(*args)
            if 'fptype' in kwargs and kwargs['fptype'] == float32:
                    if 'method' not in kwargs or kwargs['method'] == defaultDense:
                        return Distributed_Step1LocalFloat32DefaultDense(*args)
        if step == daal.step2Master:
            if 'fptype' not in kwargs or kwargs['fptype'] == float64:
                    if 'method' not in kwargs or kwargs['method'] == defaultDense:
                        return Distributed_Step2MasterFloat64DefaultDense(*args)
            if 'fptype' in kwargs and kwargs['fptype'] == float32:
                    if 'method' not in kwargs or kwargs['method'] == defaultDense:
                        return Distributed_Step2MasterFloat32DefaultDense(*args)
        if step == daal.step3Local:
            if 'fptype' not in kwargs or kwargs['fptype'] == float64:
                    if 'method' not in kwargs or kwargs['method'] == defaultDense:
                        return Distributed_Step3LocalFloat64DefaultDense(*args)
            if 'fptype' in kwargs and kwargs['fptype'] == float32:
                    if 'method' not in kwargs or kwargs['method'] == defaultDense:
                        return Distributed_Step3LocalFloat32DefaultDense(*args)

        raise RuntimeError("No appropriate constructor found for Distributed")

class Batch(object):
    r"""Factory class for different types of Batch."""
    def __new__(cls,
                *args, **kwargs):
        if 'fptype' not in kwargs or kwargs['fptype'] == float64:
            if 'method' not in kwargs or kwargs['method'] == defaultDense:
                return Batch_Float64DefaultDense(*args)
        if 'fptype' in kwargs and kwargs['fptype'] == float32:
            if 'method' not in kwargs or kwargs['method'] == defaultDense:
                return Batch_Float32DefaultDense(*args)

        raise RuntimeError("No appropriate constructor found for Batch")


# This file is compatible with both classic and new-style classes.


